﻿// <auto-generated />
using System;
using GameServer.Data;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace GameServer.Data.Migrations
{
    [DbContext(typeof(GameServerDbContext))]
    partial class GameServerDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.1.0-rtm-30799")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("GameServer.Data.Account", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Password");

                    b.Property<string>("Username");

                    b.HasKey("Id");

                    b.ToTable("Accounts");
                });

            modelBuilder.Entity("GameServer.Data.Character", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<Guid?>("AccountId");

                    b.Property<Guid?>("FaceId");

                    b.Property<Guid?>("HeadId");

                    b.Property<Guid?>("HeldLeftHandId");

                    b.Property<Guid?>("HeldRightHandId");

                    b.Property<Guid?>("LeftArmId");

                    b.Property<Guid?>("LeftFootId");

                    b.Property<Guid?>("LeftHandId");

                    b.Property<Guid?>("LeftLegId");

                    b.Property<Guid?>("LeftShoulderId");

                    b.Property<string>("Name");

                    b.Property<Guid?>("RightArmId");

                    b.Property<Guid?>("RightFootId");

                    b.Property<Guid?>("RightHandId");

                    b.Property<Guid?>("RightLegId");

                    b.Property<Guid?>("RightShoulderId");

                    b.Property<double>("Rotation");

                    b.Property<Guid?>("UpperBodyId");

                    b.Property<Guid?>("WaistId");

                    b.Property<Guid>("Zone");

                    b.Property<double>("ZoneX");

                    b.Property<double>("ZoneY");

                    b.Property<double>("ZoneZ");

                    b.HasKey("Id");

                    b.HasIndex("AccountId");

                    b.HasIndex("FaceId");

                    b.HasIndex("HeadId");

                    b.HasIndex("HeldLeftHandId");

                    b.HasIndex("HeldRightHandId");

                    b.HasIndex("LeftArmId");

                    b.HasIndex("LeftFootId");

                    b.HasIndex("LeftHandId");

                    b.HasIndex("LeftLegId");

                    b.HasIndex("LeftShoulderId");

                    b.HasIndex("RightArmId");

                    b.HasIndex("RightFootId");

                    b.HasIndex("RightHandId");

                    b.HasIndex("RightLegId");

                    b.HasIndex("RightShoulderId");

                    b.HasIndex("UpperBodyId");

                    b.HasIndex("WaistId");

                    b.ToTable("Characters");
                });

            modelBuilder.Entity("GameServer.Data.Item", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<Guid?>("CharacterId");

                    b.Property<string>("Description");

                    b.Property<string>("Discriminator")
                        .IsRequired();

                    b.Property<string>("Name");

                    b.Property<int>("Rarity");

                    b.HasKey("Id");

                    b.HasIndex("CharacterId");

                    b.ToTable("Item");

                    b.HasDiscriminator<string>("Discriminator").HasValue("Item");
                });

            modelBuilder.Entity("GameServer.Data.Equipment", b =>
                {
                    b.HasBaseType("GameServer.Data.Item");

                    b.Property<int>("Slot");

                    b.ToTable("Equipment");

                    b.HasDiscriminator().HasValue("Equipment");
                });

            modelBuilder.Entity("GameServer.Data.Resource", b =>
                {
                    b.HasBaseType("GameServer.Data.Item");

                    b.Property<float>("Quality");

                    b.ToTable("Resource");

                    b.HasDiscriminator().HasValue("Resource");
                });

            modelBuilder.Entity("GameServer.Data.Character", b =>
                {
                    b.HasOne("GameServer.Data.Account")
                        .WithMany("Characters")
                        .HasForeignKey("AccountId");

                    b.HasOne("GameServer.Data.Equipment", "Face")
                        .WithMany()
                        .HasForeignKey("FaceId");

                    b.HasOne("GameServer.Data.Equipment", "Head")
                        .WithMany()
                        .HasForeignKey("HeadId");

                    b.HasOne("GameServer.Data.Equipment", "HeldLeftHand")
                        .WithMany()
                        .HasForeignKey("HeldLeftHandId");

                    b.HasOne("GameServer.Data.Equipment", "HeldRightHand")
                        .WithMany()
                        .HasForeignKey("HeldRightHandId");

                    b.HasOne("GameServer.Data.Equipment", "LeftArm")
                        .WithMany()
                        .HasForeignKey("LeftArmId");

                    b.HasOne("GameServer.Data.Equipment", "LeftFoot")
                        .WithMany()
                        .HasForeignKey("LeftFootId");

                    b.HasOne("GameServer.Data.Equipment", "LeftHand")
                        .WithMany()
                        .HasForeignKey("LeftHandId");

                    b.HasOne("GameServer.Data.Equipment", "LeftLeg")
                        .WithMany()
                        .HasForeignKey("LeftLegId");

                    b.HasOne("GameServer.Data.Equipment", "LeftShoulder")
                        .WithMany()
                        .HasForeignKey("LeftShoulderId");

                    b.HasOne("GameServer.Data.Equipment", "RightArm")
                        .WithMany()
                        .HasForeignKey("RightArmId");

                    b.HasOne("GameServer.Data.Equipment", "RightFoot")
                        .WithMany()
                        .HasForeignKey("RightFootId");

                    b.HasOne("GameServer.Data.Equipment", "RightHand")
                        .WithMany()
                        .HasForeignKey("RightHandId");

                    b.HasOne("GameServer.Data.Equipment", "RightLeg")
                        .WithMany()
                        .HasForeignKey("RightLegId");

                    b.HasOne("GameServer.Data.Equipment", "RightShoulder")
                        .WithMany()
                        .HasForeignKey("RightShoulderId");

                    b.HasOne("GameServer.Data.Equipment", "UpperBody")
                        .WithMany()
                        .HasForeignKey("UpperBodyId");

                    b.HasOne("GameServer.Data.Equipment", "Waist")
                        .WithMany()
                        .HasForeignKey("WaistId");
                });

            modelBuilder.Entity("GameServer.Data.Item", b =>
                {
                    b.HasOne("GameServer.Data.Character")
                        .WithMany("Inventory")
                        .HasForeignKey("CharacterId");
                });
#pragma warning restore 612, 618
        }
    }
}
